
rows = 10
cols = 10
diag_level = 1 #TODO: Implement this!

def mod_diagonal_matrix(matrix, i, j, value):
    diag_id = i + j
    if diag_id < rows:
        element_id = i
    else:
        element_id = j - (diag_id - rows + 1)
    #print(f"{i, j}", diag_id, element_id)
    matrix[diag_id][element_id] = value

def get_sorted_element(matrix, i, j):
    diag_id = i + j
    if diag_id < rows:
        element_id = i
    else:
        element_id = j - (diag_id - rows + 1)
    return matrix[diag_id][element_id]

def print_array(array):
    print(" ".join(map(str, array)))
        
def print_2d_matrix(matrix):
    for i in range(rows):
        for j in range(cols):
            print(f"{matrix[i*cols + j]}", end=" ")
        print(end="\n")
        
def print_diagonal_matrix(matrix):
    for i in range(len(matrix)):
        print(f"diag {i}", matrix[i])

def print_2d_diagonal_matrix(matrix):
    for i in range(rows):
        for j in range(cols):
            print(get_sorted_element(matrix, i, j), end=" ")
        print("")
                
def main():
    
    #matrix = [[f"{i},{j}" for j in range(cols)] for i in range(rows)]
    matrix = [f"{i},{j}" for i in range(rows) for j in range(cols)]
    # Init diagonal matrix:
    diagonal_matrix = ["-1"] * (rows + cols - 1)
    for i in range(rows + cols - 1):
        if i < rows:
            diagonal_matrix[i] = [None] * (i + 1)
        else:
            diagonal_matrix[i] = [None] * (rows + cols - 1 - i)
    
    #print_diagonal_matrix(diagonal_matrix)
    
    for i in range(rows):
        for j in range(cols):
            mod_diagonal_matrix(diagonal_matrix, i, j, f"{i},{j}")
    
    
    print_2d_matrix(matrix)
    print()
    print_2d_diagonal_matrix(diagonal_matrix)

if __name__ == "__main__":
    main()